<?php
/**
* quiz_stats_class.php
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Quiz stats class
*/

class quiz_stats
{

	// to avoid doing a cut and paste of this SQL over and over
	function get_full_username($user_id)
	{
	global $db;

		$user_info = "SELECT username, user_colour
					  FROM " . USERS_TABLE . "
					  WHERE user_id = " . intval($user_id);
		$user_info_result = $db->sql_query($user_info);
		$user_info_row = $db->sql_fetchrow($user_info_result);

		return get_username_string('full', intval($user_id), $user_info_row['username'], $user_info_row['user_colour']);
	}

	function best_results()
	{
	global $db, $config, $template;

		$sql = 'SELECT * FROM ' . QUIZ_STATISTICS_OVERVIEW_TABLE . '
				ORDER BY quiz_correct/(quiz_correct + quiz_incorrect) DESC';

		$result = $db->sql_query_limit($sql,  $config['quiz_show_how_many_stats']);
		
			while ($row = $db->sql_fetchrow($result))
			{
				$template->assign_block_vars('best_results_row', array(	
				'QUIZ'				=> get_quiz_title($row['quiz_id']),
				'CORRECT'			=> $row['quiz_correct'],
				'INCORRECT'			=> $row['quiz_incorrect'],
				'PERCENTAGE'		=> number_format((100*$row['quiz_correct'])/($row['quiz_incorrect']+$row['quiz_correct']), 0) . '%',
				'USER'				=> $this->get_full_username($row['user_id']),
				));
			}

		$db->sql_freeresult($result);
	}

	function most_played()
	{
	global $user, $db, $config, $template;

		$sql = 'SELECT quiz_name, quiz_author, quiz_date, quiz_views FROM ' . QUIZ_TABLE . '
				ORDER BY quiz_views DESC';

		$result = $db->sql_query_limit($sql, $config['quiz_show_how_many_stats']);
		
			while ($row = $db->sql_fetchrow($result))
			{
				$template->assign_block_vars('most_played_row', array(	
				'QUIZ'				=> $row['quiz_name'],
				'PLAYS'				=> $row['quiz_views'],
				'DATE'				=> $user->format_date($row['quiz_date']),
				'AUTHOR'			=> $this->get_full_username($row['quiz_author']),
				));
			}

		$db->sql_freeresult($result);
	}

	function most_correct_answers()
	{
	global $user, $db, $config, $template;

		$sql = 'SELECT SUM(quiz_correct) AS sum_correct, SUM(quiz_incorrect) AS sum_incorrect, user_id FROM ' . QUIZ_STATISTICS_OVERVIEW_TABLE . '
				GROUP BY quiz_correct
				ORDER BY sum_correct DESC';

		$result = $db->sql_query_limit($sql, $config['quiz_show_how_many_stats']);
		
			while ($row = $db->sql_fetchrow($result))
			{
				$all_played = $row['sum_incorrect'] + $row['sum_correct'];

				$template->assign_block_vars('most_correct_answers_row', array(	
				'AUTHOR'			=> $this->get_full_username($row['user_id']),
				'CORRECT'			=> $row['sum_correct'],
				'INCORRECT'			=> $row['sum_incorrect'],
				'PERCENTAGE'		=> ($all_played > 0) ? number_format((100*$row['sum_correct'])/($all_played), 0) . '%' : '-',
				));
			}

		$db->sql_freeresult($result);
	}

	/* function high_percentage_correct_answers()
	{
	global $user, $db, $config, $template;

		$sql = 'SELECT SUM(quiz_correct) AS sum_correct, SUM(quiz_incorrect) AS sum_incorrect, 
				(sum_correct/(sum_correct + sum_incorrect)) AS ratio, user_id 
					CASE WHEN sum_incorrect = 0
            then null
            else vote_calc
               / vote_amount
         end as e
				FROM ' . QUIZ_STATISTICS_OVERVIEW_TABLE . '
				GROUP BY quiz_correct
				ORDER BY ratio DESC';

		$result = $db->sql_query_limit($sql, $config['quiz_show_how_many_stats']);
		
			while ($row = $db->sql_fetchrow($result))
			{
				$template->assign_block_vars('most_percentage_correct_answers_row', array(	
				'AUTHOR'			=> $this->get_full_username($row['user_id']),
				'CORRECT'			=> $row['sum_correct'],
				'INCORRECT'			=> $row['sum_incorrect'],
				'PERCENTAGE'		=> number_format((100*$row['sum_correct'])/($row['sum_incorrect']+$row['sum_correct']), 0) . '%',
				));
			}

		$db->sql_freeresult($result);
	} */
}
?>