<?php
/**
*
* @package phpBB3
* @version $Id: quiz_cp.php
* @copyright (c) 2008, 2009 battye, CricketMX.com
* Ultimate Quiz MOD v2.0.0
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_quiz.' . $phpEx);
include($phpbb_root_path . 'includes/quiz_stats_class.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/quiz');

// Grab data
$mode = request_var('mode', '');

	if( !$user->data['is_registered'] )
	{
		trigger_error('QUIZ_MUST_BE_LOGGED_IN');
	}

	// By default, we will see admins only. But admins can allow users to edit their own if they want to
	if( intval($config['quiz_user_edit_own_quiz']) == 1 )
	{
		$quiz_user_edit_own_quiz = true;
	}

	else if( !$auth->acl_get('a_') ) // $auth->acl_get('a_') tells us if you are admin
	{
	// Admins only, so may as well stop the page here

	trigger_error('QUIZ_MUST_ADMIN_USER');
	}

// We will have three categories: Move quiz to another category, delete quiz, edit quiz
// Let's start with the hardest first
if( $mode == 'edit' )
{
	page_header($user->lang['QUIZ_EDIT_ASK']);

	$quiz_id = request_var('q', 0);

	$sql 	=  "SELECT quiz_name, quiz_author
				FROM " . QUIZ_TABLE . "
				WHERE quiz_id = $quiz_id";
	$result =  $db->sql_query($sql);

	$row 	=  $db->sql_fetchrow($result);

	$author_id = $row['quiz_author'];
	$quiz_name = $row['quiz_name'];

	// $list_of_question_ids = '';
	// $list_of_data_id = '';

	check_quiz_edit_status($quiz_user_edit_own_quiz, $author_id, $user->data['user_id']);

	if( request_var('action', '') == 'submit' )
	{
		$update_sql = array(); // This will be used for quite a few queries.

		$sql = "SELECT quiz_question_id FROM " . QUIZ_QUESTIONS_TABLE . " 
				WHERE quiz_related_id = $quiz_id";
		$result = $db->sql_query($sql);

		// Loop the questions
		while( $row = $db->sql_fetchrow($result) )
		{
			$question_name = request_var('question_name_' . $row['quiz_question_id'], '', true);
			$data_sql = "SELECT quiz_data_id FROM " . QUIZ_DATA_TABLE . "
						 WHERE quiz_question_id = " . $row['quiz_question_id'];
			$data_result = $db->sql_query($data_sql);

			// Loop the multiple choice/s
			while( $data_row = $db->sql_fetchrow($data_result) )
			{
				$multiple_answer = request_var('answer_' . $data_row['quiz_data_id'], '', true);
				$is_correct = (request_var('correct_' . $row['quiz_question_id'], 0) == $data_row['quiz_data_id']) ? 1 : 0;

				// Sort bbCode
				$uid = $bitfield = $options = '';
				$allow_bbcode = $allow_urls = $allow_smilies = true;

				generate_text_for_storage($multiple_answer, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);

				$update_array = array(
  					'quiz_correct'				=> $is_correct,
  					'quiz_answer'				=> utf8_normalize_nfc($multiple_answer),
  					'quiz_uid'					=> $uid,
					'quiz_bitfield'				=> $bitfield,
					'quiz_options'				=> $options,
				);

				$update_sql[] = 'UPDATE ' . QUIZ_DATA_TABLE . '
  								 SET ' . $db->sql_build_array('UPDATE', $update_array) . '
   								 WHERE quiz_data_id = ' . (int) $data_row['quiz_data_id'];
			}

			// Sort bbCode
			$uid = $bitfield = $options = '';
			$allow_bbcode = $allow_urls = $allow_smilies = true;

			generate_text_for_storage($question_name, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);

			$update_question_array = array(
  				'quiz_question'				=> utf8_normalize_nfc($question_name),
  				'quiz_uid'					=> $uid,
				'quiz_bitfield'				=> $bitfield,
				'quiz_options'				=> $options,
			);

			$update_sql[] = 'UPDATE ' . QUIZ_QUESTIONS_TABLE . '
  							 SET ' . $db->sql_build_array('UPDATE', $update_question_array) . '
   							 WHERE quiz_question_id = ' . (int) $row['quiz_question_id'];
		}

		$update_name_array = array(
  			'quiz_name'		=> utf8_normalize_nfc(request_var('quiz_name', '', true)),
		);

		$update_sql[] = 'UPDATE ' . QUIZ_TABLE . '
  						 SET ' . $db->sql_build_array('UPDATE', $update_name_array) . '
   						 WHERE quiz_id = ' . (int) $quiz_id;

		$size_update_sql = sizeof($update_sql);

			for ($u = 0; $u < $size_update_sql; $u++)
			{
				// For debugging, if required
				// echo $update_sql[$u] . '<br /><br />';

				$db->sql_query($update_sql[$u]);
			}

	trigger_error(sprintf($user->lang['QUIZ_EDIT_SUCCESSFUL'], '<a href="' . append_sid("{$phpbb_root_path}quiz_cp.$phpEx") . '">', '</a>'));
	}

		$questions_sql = "SELECT * FROM " . QUIZ_QUESTIONS_TABLE . " 
						  WHERE quiz_related_id = $quiz_id";
		$questions_result = $db->sql_query($questions_sql);

		while( $questions_row = $db->sql_fetchrow($questions_result) )
		{
			$quiz_question = strip_bbcode($questions_row['quiz_question'], $questions_row['quiz_uid']);

				$template->assign_block_vars('question_row', array(	
				'QUESTION_NAME'			=> $questions_row['quiz_question'],
				'QUESTION_ID'			=> $questions_row['quiz_question_id'],
				));

			// $list_of_question_ids .= $questions_row['quiz_question_id'] . ',';

			$data_sql = "SELECT * FROM " . QUIZ_DATA_TABLE . "
						 WHERE quiz_question_id = " . $questions_row['quiz_question_id'];

			$data_result = $db->sql_query($data_sql);

			while( $data_row = $db->sql_fetchrow($data_result) )
			{
				$quiz_answer = $data_row['quiz_answer'];
				$quiz_correct = (int) $data_row['quiz_correct'];
				$quiz_data_id = (int) $data_row['quiz_data_id'];

				decode_message($quiz_answer, $data_row['quiz_uid']);

					$template->assign_block_vars('question_row.answer_row', array(	
					'ANSWER_NAME'			=> $quiz_answer,
					'ANSWER_ID'				=> $quiz_data_id,
					'ANSWER_SELECTED'		=> ($quiz_correct) ? 'checked="checked"' : '',
					));

				// $list_of_data_id .= $quiz_data_id . ',';
			}
		}

        // $s_hidden_fields = build_hidden_fields(array(
        //   	'list_of_data_ids'			=> $list_of_data_id,
		//	'list_of_question_ids'		=> $true_false_questions,
		// ));

	$template->assign_vars( array(
	'S_SUBMIT_QUIZ_ACTION'		=> append_sid("{$phpbb_root_path}quiz_cp.$phpEx", "mode=edit&amp;q=$quiz_id&amp;action=submit"),
	'U_QUIZ_NAME'				=> $quiz_name,
	));

	$template->set_filenames(array(	
	'body' => 'quiz_cp_edit_body.html')
	);

	page_footer();
}

else if( $mode == 'move' )
{
	page_header($user->lang['QUIZ_MOVE_ASK']);

	$quiz_id = request_var('q', 0);
	$author_id = get_author_of_quiz($quiz_id);

	check_quiz_edit_status($quiz_user_edit_own_quiz, $author_id, $user->data['user_id']);

	if( request_var('action', '') == 'submit' )
	{
		$move_to_category = request_var('select_category', 0);

			if( $move_to_category < 1 )
			{
				trigger_error('QUIZ_MOVE_UNSUCCESSFUL');
			}

		$sql_ary = array('quiz_category' => $move_to_category);
		
		$sql = 'UPDATE ' . QUIZ_TABLE . '
				SET ' . $db->sql_build_array('UPDATE', $sql_ary) . '
  				WHERE quiz_id = ' . $quiz_id;

		$db->sql_query($sql);
				
		trigger_error(sprintf($user->lang['QUIZ_MOVE_SUCCESSFUL'], '<a href="' . append_sid("{$phpbb_root_path}quiz_cp.$phpEx") . '">', '</a>'));
	}

	$sql = "SELECT quiz_category
			FROM " . QUIZ_TABLE . "
			WHERE quiz_id = $quiz_id";
	$result = $db->sql_query($sql);

	$category_id = $db->sql_fetchfield('quiz_category');
	$category_name = get_category_name($category_id);

	$category_dropdown = quiz_category_list('');

	$db->sql_freeresult($result);

		$template->assign_vars( array(	
		'S_SUBMIT_QUIZ_ACTION'			=> append_sid("{$phpbb_root_path}quiz_cp.$phpEx", "mode=move&amp;q=$quiz_id&amp;action=submit"),
		'U_CATEGORY_DROPDOWN'			=> $category_dropdown,

		'L_QUIZ_MOVE_ASK_CONFIRM'		=> sprintf($user->lang['QUIZ_MOVE_ASK_CONFIRM'], $category_name),
		'L_QUIZ_MOVE_TO'				=> sprintf($user->lang['QUIZ_MOVE_TO'], $category_name),
		));

	$template->set_filenames(array(	
	'body' => 'quiz_cp_move_body.html')
	);

	page_footer();
}

else if( $mode == 'delete' )
{
	$quiz_id = request_var('q', 0);
	$author_id = get_author_of_quiz($quiz_id);

	check_quiz_edit_status($quiz_user_edit_own_quiz, $author_id, $user->data['user_id']);

    if( confirm_box(true) )
    {
		$sql[] = "DELETE FROM " . QUIZ_TABLE . " WHERE quiz_id = $quiz_id";
		// $sql[] = "DELETE FROM " . QUIZ_DATA_TABLE . " WHERE quiz_id = $quiz_id";
		$sql[] = "DELETE FROM " . QUIZ_QUESTIONS_TABLE . " WHERE quiz_related_id = $quiz_id";
		$sql[] = "DELETE FROM " . QUIZ_PROGRESSIVE_TABLE . " WHERE quiz_id = $quiz_id";
		$sql[] = "DELETE FROM " . QUIZ_STATISTICS_TABLE . " WHERE quiz_id = $quiz_id";
		$sql[] = "DELETE FROM " . QUIZ_STATISTICS_OVERVIEW_TABLE . " WHERE quiz_id = $quiz_id";

		$size_sql = sizeof($sql);
		
			for ($u = 0; $u < $size_sql; $u++)
			{
				$db->sql_query($sql[$u]);
			}
		
		trigger_error(sprintf($user->lang['QUIZ_DELETE_SUCCESSFUL'], '<a href="' . append_sid("{$phpbb_root_path}quiz_cp.$phpEx") . '">', '</a>'));
	}

    else
    {
		if( request_var('confirm_key', '') )
		{
			redirect('quiz_cp.'.$phpEx);
		}
		
		confirm_box(false, 'QUIZ_DELETE_ASK');
	}
}

else // Display the 'home' page
{
page_header($user->lang['QUIZ_CP']);

	// We will display all the quizzes along with the links to manipulate them
	// Start with the categories, then the quiz names

	$sql = "SELECT quiz_category_name, quiz_category_id 	
			FROM " . QUIZ_CATEGORY_TABLE;

	$result = $db->sql_query($sql);

		while( $row = $db->sql_fetchrow($result) )
		{
			$template->assign_block_vars('home_row', array(	
			'CATEGORY_NAME'			=> $row['quiz_category_name'],
			));

			$where_clause = ($quiz_user_edit_own_quiz && !$auth->acl_get('a_')) ? 'AND quiz_author = ' . $user->data['user_id'] : '';

			$quizzes_sql = "SELECT quiz_name, quiz_author, quiz_id
							FROM " . QUIZ_TABLE . "
							WHERE quiz_category = " . $row['quiz_category_id'] . "
							$where_clause
							ORDER BY quiz_name ASC";

			$quizzes_result = $db->sql_query($quizzes_sql);

			while( $quizzes_row = $db->sql_fetchrow($quizzes_result) )
			{
				$template->assign_block_vars('home_row.quiz_row', array(	
				'QUIZ_NAME'			=> $quizzes_row['quiz_name'],
				'QUIZ_EDIT_LINK'	=> append_sid("{$phpbb_root_path}quiz_cp.$phpEx", 'mode=edit&amp;q='.$quizzes_row['quiz_id']),
				'QUIZ_MOVE_LINK'	=> append_sid("{$phpbb_root_path}quiz_cp.$phpEx", 'mode=move&amp;q='.$quizzes_row['quiz_id']),
				'QUIZ_DELETE_LINK'	=> append_sid("{$phpbb_root_path}quiz_cp.$phpEx", 'mode=delete&amp;q='.$quizzes_row['quiz_id']),
				));
			}

			$db->sql_freeresult($quizzes_result);
		}

	$db->sql_freeresult($result);

	$template->set_filenames(array(	
	'body' => 'quiz_cp_body.html')
	);

	page_footer();
}
?>